<?php

namespace Services;
use Util\WkfUtilities as WkfUtilities;

class ConnectionIntegraWebService {

    protected $options;
    protected $curl;

    public function __construct(WkfUtilities $wkfUtilities) {
        $this->wkfUtilities = $wkfUtilities;
    }

    public function getSupplierCode($cdSupplier)
    {
        $query = "SELECT CDFORNECED FROM FORNECEDOR WHERE CDFORNECED LIKE '%'||:P_CDFORNECED";
        $param = ['P_CDFORNECED' => $cdSupplier];
        return $this->wkfUtilities->crud($query, $param);
    }

    public function getAvailableServices($cdSupplier = 'T') {
        $query = "SELECT F.NMFANTFORN, I.* FROM USR_PARAMINTEGRA I, FORNECEDOR F WHERE F.CDFORNECED = I.CDFORNECED AND ((I.CDFORNECED = :P_CDFORNECED) OR :P_CDFORNECED = 'T')";
        if($cdSupplier) {
            $param = ['P_CDFORNECED' => $cdSupplier];
            return $this->wkfUtilities->crud($query, $param);
        } else {
            return $this->wkfUtilities->crud($query, $param);
        }
    }

    public function connectWebService($service, $xml = null) {
        if($xml) {
            $postBody = $xml;
            $host = $service['DSDIRENVIO'];
        } else {
            $postBody = "<?xml version=1.0?><arquivo><info><nome-remetente>SAPORE</nome-remetente><nome-destinatario>".$service['NMFANTFORN']."</nome-destinatario><key>".$service['DSLOGIN']."</key><auth>".$service['DSSENHA']."</auth></info></arquivo>";
            $host = $service['DSHOST'];
        }
        return self::postCurl($host, $postBody);
    }

    private function postCurl($host, $postBody) {
        $this->curl = curl_init();
        $this->options = [
            CURLOPT_URL            => $host,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_TIMEOUT        => 120,
            CURLOPT_CUSTOMREQUEST  => "POST",
            CURLOPT_POSTFIELDS     => $postBody,
            CURLOPT_HTTPHEADER     => [ "content-type: text/xml" ]
        ];
        curl_setopt_array($this->curl, $this->options);
        $response = curl_exec($this->curl);
        curl_close($this->curl);
        return $response;
    }


}