<?php

namespace Services;

use Util\WkfUtilities;

class ReportOrderService
{

    public function __construct(WkfUtilities $wkfUtilities)
    {
        $this->wkfUtilities = $wkfUtilities;
    }

    public function getParamsIntegra($cdSupplier)
    {
        $query = "SELECT DSDIRENVIO, DSLOGIN, DSSENHA FROM USR_PARAMINTEGRA WHERE CDFORNECED = :P_CDFORNECED";
        $param = ["P_CDFORNECED" => $cdSupplier];
        return $this->wkfUtilities->crud($query, $param)[0];
    }

    public function getSupplier($cdSupplier)
    {
        $query = "SELECT NMFANTFORN FROM FORNECEDOR WHERE CDFORNECED = :P_CDFORNECED";
        $param = ["P_CDFORNECED" => $cdSupplier];
        return $this->wkfUtilities->crud($query, $param)[0]['NMFANTFORN'];
    }

    public function getNumOrder($nrAutoForn)
    {
        $query = "SELECT USR_NRIMPORTAF FROM AUTOFORNE WHERE NRAUTOFORN = :P_NRAUTOFORN";
        $param = ['P_NRAUTOFORN' => $nrAutoForn];
        return $this->wkfUtilities->crud($query, $param);
    }

    public function getLogError($numOrder)
    {
        $query = "SELECT * FROM LOGIMPITEMAUTF WHERE USR_NRIMPORTAF = :P_USR_NRIMPORTAF";
        $params = [ 'P_USR_NRIMPORTAF' => $numOrder ];
        return $this->wkfUtilities->crud($query, $params);
    }

    public function getUserLog($cdSupplier)
    {
        $query = "SELECT CDOPERADOR FROM USR_PARAMINTEGRA WHERE CDFORNECED = :P_CDFORNECED";
        $param = ['P_CDFORNECED' => $cdSupplier];
        return $this->wkfUtilities->crud($query, $param);
    }

    public function getUserLogParams($cdoperador) {
        $query = "SELECT NMOPERADOR, DSEMAILOPER FROM OPERADOR WHERE CDOPERADOR = :P_CDOPERADOR";
        $param = ['P_CDOPERADOR' => $cdoperador];
        return $this->wkfUtilities->crud($query, $param);
    }

}
