<?php
namespace Services;

class TimeLineService {

    protected $connection;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager){
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
    }

    public function getDemanda($NRAUTOFORN) {
        $sql = "SELECT DISTINCT * FROM AUTOFORNE WHERE NRAUTOFORN = :NRAUTOFORN";
        try {
            $std = $this->connection->prepare($sql);
            $std->execute(['NRAUTOFORN' => $NRAUTOFORN]);
            return $std->fetchAll()[0];
        }
        catch (Exception $e){
            throw $e;
        }
    }
   public function getAprovadores($params) {
        $sql = "SELECT NVL( A.CDOPERAPROV, G.CDOPERADOR ) AS CDOPERAPROV, A.NRDEMANDA, O.NMOPERADOR, A.IDAPROVADO, G.VRAPROVCMP, TO_CHAR( A.DTAPROVACAO, 'DD/MM/YYYY HH24:MI:SS' ) DTAPROVACAO, TO_CHAR( A.DTINCLUSAO, 'DD/MM/YYYY HH24:MI:SS' ) DTINCLUSAO, GER.NMOPERADOR APROVPRINC, A.DSJUSTIFICA, A.NRORG, ( SELECT MIN(B.VRAPROVCMP) FROM ALCADAGERFILI B WHERE B.CDFILIAL = G.CDFILIAL AND B.NRCONFIGALCADA = G.NRCONFIGALCADA AND B.VRAPROVCMP > G.VRAPROVCMP ) VRAPROVCMPMAX FROM APROVALCADA A, OPERADOR O, ALCADAGERFILI G, OPERADOR GER WHERE A.NRCONFIGALCADA =:NRCONFIGALCADA AND A.CDFILDEST =:CDFILDEST AND CDFILLANC =:CDFILLANC AND NRDEMANDA =:NRDEMANDA AND NVL( A.CDOPERAPROV, A.CDOPERADOR ) = O.CDOPERADOR AND A.NRCONFIGALCADA = G.NRCONFIGALCADA AND A.CDFILDEST = G.CDFILIAL AND A.CDOPERADOR = G.CDOPERADOR AND A.CDOPERADOR = GER.CDOPERADOR UNION SELECT G.CDOPERADOR, '' NRDEMANDA, O.NMOPERADOR, 'PENDENTE' IDAPROVADO, VRAPROVCMP, '' DTAPROVACAO, '' DTINCLUSAO, '' APROVPRINC, '' DSJUSTIFICA, G.NRORG, ( SELECT MIN(B.VRAPROVCMP) FROM ALCADAGERFILI B WHERE B.CDFILIAL = G.CDFILIAL AND B.NRCONFIGALCADA = G.NRCONFIGALCADA AND B.VRAPROVCMP > G.VRAPROVCMP ) VRAPROVCMPMAX FROM ALCADAGERFILI G, OPERADOR O WHERE G.NRCONFIGALCADA =:NRCONFIGALCADA AND G.CDFILIAL =:CDFILDEST AND G.CDOPERADOR = O.CDOPERADOR AND NOT EXISTS ( SELECT 1 FROM APROVALCADA A WHERE A.NRCONFIGALCADA = G.NRCONFIGALCADA AND A.CDFILDEST = G.CDFILIAL AND A.NRDEMANDA =:NRDEMANDA AND A.CDOPERADOR = G.CDOPERADOR ) ORDER BY VRAPROVCMP";
        try {
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        }
        catch(Exception $e) {
            throw $e;
        }
    }

    public function getIdAprovado($cdOperador, $nrDemanda) {
        $sql = "SELECT IDAPROVADO FROM APROVALCADA WHERE CDOPERADOR = :P_CDOPERADOR AND NRDEMANDA = :P_NRDEMANDA";
        try {
            $std = $this->connection->prepare($sql);
            $std->execute([
                "P_CDOPERADOR" => $cdOperador,
                "P_NRDEMANDA"  => $nrDemanda
            ]);
            return $std->fetchAll();
        }
        catch(Exception $e) {
            throw $e;
        }
    }
    
    public function returnMountedArray($aprovador, $state) {
        return (
            array(
                "CDOPERAPROV"   => $aprovador['CDOPERAPROV'],
                "NMOPERADOR"    => $aprovador['NMOPERADOR'],
                "NRDEMANDA"     => $aprovador['NRDEMANDA'],
                "IDAPROVADO"    => $aprovador['IDAPROVADO'],
                "DTAPROVACAO"   => $aprovador['DTAPROVACAO'],
                "DTINCLUSAO"    => $aprovador['DTINCLUSAO'],
                "SITUACAO"      => $state,
                "VRAPROVCMP"    => $aprovador['VRAPROVCMP'],
                "VRAPROVCMPMAX" => $aprovador['VRAPROVCMPMAX'],
                "APROVPRINC"    => $aprovador['APROVPRINC'],
                "DSJUSTIFICA"   => $aprovador['DSJUSTIFICA']
            )
        );
    }
}