/* Tabela ALIQUOTA: Alquota */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela ALIQUOTA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Alquota,
             utilizando a tabela Geral de Logs de Operaes */


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FIS_ALIQUOTA' AND
                 TYPE   = 'TR' 		         AND
	              U.UID  = O.UID              AND
	              U.NAME = USER)
DROP TRIGGER LOG_FIS_ALIQUOTA
GO


CREATE TRIGGER LOG_FIS_ALIQUOTA
ON ALIQUOTA
FOR INSERT, UPDATE, DELETE
AS

   DECLARE  @V_USUARIO          VARCHAR(40);
   DECLARE  @V_TIPO             VARCHAR(1);
   DECLARE  @V_ITPESQ           VARCHAR(40);
   DECLARE  @V_DESC             VARCHAR(300);
   DECLARE  @V_DTOPER           DATETIME;
   DECLARE  @V_IDTIPO           VARCHAR(1);
   DECLARE  @V_CDARVPROD_OLD    VARCHAR(20);
   DECLARE  @V_CDARVPROD_NEW    VARCHAR(20);    

/*VARIVEIS DO CURSOR C_CURSORal*/

   DECLARE  @V_ID_COMANDO      VARCHAR(1);

   DECLARE  @V_IDENTRSAIDAL_OLD VARCHAR(1);
   DECLARE  @V_CDTIPOOPER_OLD   VARCHAR(2);
   DECLARE  @V_CDIMPOSTO_OLD    VARCHAR(2);
   DECLARE  @V_CDEMPRESA_OLD    VARCHAR(2);
   DECLARE  @V_CDINSCESTA_OLD   VARCHAR(16);
   DECLARE  @V_CDPRODUTO_OLD    VARCHAR(10);
   DECLARE  @V_CDPAISORIG_OLD   VARCHAR(4);
   DECLARE  @V_SGESTAORIG_OLD   VARCHAR(2);
   DECLARE  @V_CDMUNIORIG_OLD   VARCHAR(4);
   DECLARE  @V_CDPAISDEST_OLD   VARCHAR(4);
   DECLARE  @V_SGESTADEST_OLD   VARCHAR(2);
   DECLARE  @V_DTINIVALID_OLD   DATETIME;
   DECLARE  @V_VRINIFAIXA_OLD   DOUBLE PRECISION;
   DECLARE  @V_VRFIMFAIXA_OLD   DOUBLE PRECISION;
   DECLARE  @V_VRPARDEDUZ_OLD   DOUBLE PRECISION;
   DECLARE  @V_VRPERREDBC_OLD   DOUBLE PRECISION;
   DECLARE  @V_VRALIQUOTA_OLD   DOUBLE PRECISION;
   DECLARE  @V_CDGRUPOFISC_OLD  VARCHAR(3);
   DECLARE  @V_IDTRATIMPST_OLD  VARCHAR(1);
   DECLARE  @V_VRPBCSUBTRIB_OLD DOUBLE PRECISION;
   DECLARE  @V_IDMUNIORIDES_OLD VARCHAR(1);
   DECLARE  @V_NRALIQUOTA_OLD   VARCHAR(10);
   DECLARE  @v_VR1PERREDBC_OLD  DOUBLE PRECISION;
   DECLARE  @V_CDMUNIDEST_OLD   VARCHAR(4);

   DECLARE  @V_IDENTRSAIDAL_NEW VARCHAR(1);
   DECLARE  @V_CDTIPOOPER_NEW   VARCHAR(2);
   DECLARE  @V_CDIMPOSTO_NEW    VARCHAR(2);
   DECLARE  @V_CDEMPRESA_NEW    VARCHAR(2);
   DECLARE  @V_CDINSCESTA_NEW   VARCHAR(16);
   DECLARE  @V_CDPRODUTO_NEW    VARCHAR(10);
   DECLARE  @V_CDPAISORIG_NEW   VARCHAR(4);
   DECLARE  @V_SGESTAORIG_NEW   VARCHAR(2);
   DECLARE  @V_CDMUNIORIG_NEW   VARCHAR(4);
   DECLARE  @V_CDPAISDEST_NEW   VARCHAR(4);
   DECLARE  @V_SGESTADEST_NEW   VARCHAR(2);
   DECLARE  @V_DTINIVALID_NEW   DATETIME;
   DECLARE  @V_VRINIFAIXA_NEW   DOUBLE PRECISION;
   DECLARE  @V_VRFIMFAIXA_NEW   DOUBLE PRECISION;
   DECLARE  @V_VRPARDEDUZ_NEW   DOUBLE PRECISION;
   DECLARE  @V_VRPERREDBC_NEW   DOUBLE PRECISION;
   DECLARE  @V_VRALIQUOTA_NEW   DOUBLE PRECISION;
   DECLARE  @V_CDGRUPOFISC_NEW  VARCHAR(3);
   DECLARE  @V_IDTRATIMPST_NEW  VARCHAR(1);
   DECLARE  @V_VRPBCSUBTRIB_NEW DOUBLE PRECISION;
   DECLARE  @V_IDMUNIORIDES_NEW VARCHAR(1);
   DECLARE  @V_NRALIQUOTA_NEW   VARCHAR(10);
   DECLARE  @V_VR1PERREDBC_NEW  DOUBLE PRECISION;
   DECLARE  @V_CDMUNIDEST_NEW   VARCHAR(4);
   
BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO,' ' );
   DECLARE C_CURSORal CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         IDENTRSAIDAL,
         CDTIPOOPER,
         CDIMPOSTO,
         CDEMPRESA,
         CDINSCESTA,
         CDPRODUTO,
         CDPAISORIG,
         SGESTAORIG,
         CDMUNIORIG,
         CDPAISDEST,
         SGESTADEST,
         DTINIVALID,
         VRINIFAIXA,
         VRFIMFAIXA,
         VRPARDEDUZ,
         VRPERREDBC,
         VRALIQUOTA,
         CDGRUPOFISC,
         IDTRATIMPST,
         VRPBCSUBTRIB,
         IDMUNIORIDES,
         NRALIQUOTA,
         VR1PERREDBC,
         CDMUNIDEST,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
    	   NULL,
         NULL
      FROM
         DELETED
      WHERE
         NRALIQUOTA NOT IN (SELECT NRALIQUOTA FROM INSERTED)
      UNION ALL

      SELECT
         'U' IDCOMANDO,
         DELETED.IDENTRSAIDAL,
         DELETED.CDTIPOOPER,
         DELETED.CDIMPOSTO,
         DELETED.CDEMPRESA,
         DELETED.CDINSCESTA,
         DELETED.CDPRODUTO,
         DELETED.CDPAISORIG,
         DELETED.SGESTAORIG,
         DELETED.CDMUNIORIG,
         DELETED.CDPAISDEST,
         DELETED.SGESTADEST,
         DELETED.DTINIVALID,
         DELETED.VRINIFAIXA,
         DELETED.VRFIMFAIXA,
         DELETED.VRPARDEDUZ,
         DELETED.VRPERREDBC,
         DELETED.VRALIQUOTA,
         DELETED.CDGRUPOFISC,
         DELETED.IDTRATIMPST,
         DELETED.VRPBCSUBTRIB,
         DELETED.IDMUNIORIDES,
         DELETED.NRALIQUOTA,
    	   DELETED.VR1PERREDBC,
         DELETED.CDMUNIDEST,
         INSERTED.IDENTRSAIDAL,
         INSERTED.CDTIPOOPER,
         INSERTED.CDIMPOSTO,
         INSERTED.CDEMPRESA,
         INSERTED.CDINSCESTA,
         INSERTED.CDPRODUTO,
         INSERTED.CDPAISORIG,
         INSERTED.SGESTAORIG,
         INSERTED.CDMUNIORIG,
         INSERTED.CDPAISDEST,
         INSERTED.SGESTADEST,
         INSERTED.DTINIVALID,
         INSERTED.VRINIFAIXA,
         INSERTED.VRFIMFAIXA,
         INSERTED.VRPARDEDUZ,
         INSERTED.VRPERREDBC,
         INSERTED.VRALIQUOTA,
         INSERTED.CDGRUPOFISC,
         INSERTED.IDTRATIMPST,
         INSERTED.VRPBCSUBTRIB,
         INSERTED.IDMUNIORIDES,
         INSERTED.NRALIQUOTA,
    	   INSERTED.VR1PERREDBC,
         INSERTED.CDMUNIDEST
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.NRALIQUOTA = DELETED.NRALIQUOTA
      UNION ALL

      SELECT
         'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
    	   NULL,
         NULL,
         INSERTED.IDENTRSAIDAL,
         INSERTED.CDTIPOOPER,
         INSERTED.CDIMPOSTO,
         INSERTED.CDEMPRESA,
         INSERTED.CDINSCESTA,
         INSERTED.CDPRODUTO,
         INSERTED.CDPAISORIG,
         INSERTED.SGESTAORIG,
         INSERTED.CDMUNIORIG,
         INSERTED.CDPAISDEST,
         INSERTED.SGESTADEST,
         INSERTED.DTINIVALID,
         INSERTED.VRINIFAIXA,
         INSERTED.VRFIMFAIXA,
         INSERTED.VRPARDEDUZ,
         INSERTED.VRPERREDBC,
         INSERTED.VRALIQUOTA,
         INSERTED.CDGRUPOFISC,
         INSERTED.IDTRATIMPST,
         INSERTED.VRPBCSUBTRIB,
         INSERTED.IDMUNIORIDES,
         INSERTED.NRALIQUOTA,
    	   INSERTED.VR1PERREDBC,
         INSERTED.CDMUNIDEST
      FROM
         INSERTED
      WHERE
         NRALIQUOTA NOT IN (SELECT NRALIQUOTA FROM DELETED);

   OPEN C_CURSORal;
   FETCH NEXT FROM C_CURSORal INTO @V_ID_COMANDO,
                                 @V_IDENTRSAIDAL_OLD,
                                 @V_CDTIPOOPER_OLD,
                                 @V_CDIMPOSTO_OLD,
                                 @V_CDEMPRESA_OLD,
                                 @V_CDINSCESTA_OLD,
                                 @V_CDPRODUTO_OLD,
                                 @V_CDPAISORIG_OLD,
                                 @V_SGESTAORIG_OLD,
                                 @V_CDMUNIORIG_OLD,
                                 @V_CDPAISDEST_OLD,
                                 @V_SGESTADEST_OLD,
                                 @V_DTINIVALID_OLD,
                                 @V_VRINIFAIXA_OLD,
                                 @V_VRFIMFAIXA_OLD,
                                 @V_VRPARDEDUZ_OLD,
                                 @V_VRPERREDBC_OLD,
                                 @V_VRALIQUOTA_OLD,
                                 @V_CDGRUPOFISC_OLD,
                                 @V_IDTRATIMPST_OLD,
                                 @V_VRPBCSUBTRIB_OLD,
                                 @V_IDMUNIORIDES_OLD,
                                 @V_NRALIQUOTA_OLD,
	                 	            @V_VR1PERREDBC_OLD,
                                 @V_CDMUNIDEST_OLD,

                                 @V_IDENTRSAIDAL_NEW,
                                 @V_CDTIPOOPER_NEW,
                                 @V_CDIMPOSTO_NEW,
                                 @V_CDEMPRESA_NEW,
                                 @V_CDINSCESTA_NEW,
                                 @V_CDPRODUTO_NEW,
                                 @V_CDPAISORIG_NEW,
                                 @V_SGESTAORIG_NEW,
                                 @V_CDMUNIORIG_NEW,
                                 @V_CDPAISDEST_NEW,
                                 @V_SGESTADEST_NEW,
                                 @V_DTINIVALID_NEW,
                                 @V_VRINIFAIXA_NEW,
                                 @V_VRFIMFAIXA_NEW,
                                 @V_VRPARDEDUZ_NEW,
                                 @V_VRPERREDBC_NEW,
                                 @V_VRALIQUOTA_NEW,
                                 @V_CDGRUPOFISC_NEW,
                                 @V_IDTRATIMPST_NEW,
                                 @V_VRPBCSUBTRIB_NEW,
                                 @V_IDMUNIORIDES_NEW,
                                 @V_NRALIQUOTA_NEW,
                		            @V_VR1PERREDBC_NEW,
                                 @V_CDMUNIDEST_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_ID_COMANDO = 'D' BEGIN

         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_NRALIQUOTA_OLD;

         IF @V_CDIMPOSTO_OLD IS NOT NULL BEGIN
           SET @V_DESC = @V_DESC + 'Impo=' + @V_CDIMPOSTO_OLD;
         END;

         IF @V_CDEMPRESA_OLD IS NOT NULL BEGIN
           SET @V_DESC = @V_DESC + ' Empr=' + @V_CDEMPRESA_OLD;
         END;

         IF @V_CDINSCESTA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' InscEsta=' + @V_CDINSCESTA_OLD;
         END;

         IF @V_CDPRODUTO_OLD IS NOT NULL BEGIN
            SELECT @V_CDARVPROD_OLD = CDARVPROD
              FROM PRODUTO
             WHERE CDPRODUTO = @V_CDPRODUTO_OLD;
	         IF @V_CDARVPROD_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD_OLD;
            END;
         END;

         IF @V_CDPAISORIG_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' PaisOrig=' + @V_CDPAISORIG_OLD;
         END;

         IF @V_SGESTAORIG_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' EstaOrig=' + @V_SGESTAORIG_OLD;
         END;

         IF @V_CDMUNIORIG_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' MunicipOrig=' + @V_CDMUNIORIG_OLD;
         END;

         IF @V_CDPAISDEST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' PaisDest=' + @V_CDPAISDEST_OLD;
         END;

         IF @V_SGESTADEST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' EstaDest=' + @V_SGESTADEST_OLD;
         END;

         IF @V_CDMUNIDEST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' MunicipDest=' + @V_CDMUNIDEST_OLD;
         END;

         IF @V_DTINIVALID_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtIniVal=' + CONVERT(VARCHAR,@V_DTINIVALID_OLD);
         END;

         IF @V_VRINIFAIXA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IniFaixa=' + CONVERT(VARCHAR,@V_VRINIFAIXA_OLD);
         END;

         IF @V_VRFIMFAIXA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' FimFaixa=' + CONVERT(VARCHAR,@V_VRFIMFAIXA_OLD);
         END;

         IF @V_VRPARDEDUZ_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' ParcDedu=' + CONVERT(VARCHAR,@V_VRPARDEDUZ_OLD);
         END;

         IF @V_VRPERREDBC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' PerRecBC' + CONVERT(VARCHAR,@V_VRPERREDBC_OLD);
         END;

         IF @V_VRALIQUOTA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Aliq=' + CONVERT(VARCHAR,@V_VRALIQUOTA_OLD);
         END;

         IF @V_CDGRUPOFISC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' GrupFisc=' + @V_CDGRUPOFISC_OLD;
         END;

         IF @V_IDTRATIMPST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TratImpST=' + @V_IDTRATIMPST_OLD;
         END;

         IF @V_VRPBCSUBTRIB_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' BCSitTrib=' + CONVERT(VARCHAR,@V_VRPBCSUBTRIB_OLD);
         END;

         IF @V_IDMUNIORIDES_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' MunOrigDest=' + @V_IDMUNIORIDES_OLD;
         END;

         IF @V_IDENTRSAIDAL_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdEntrSaid=' + @V_IDENTRSAIDAL_OLD;
         END;

         IF @V_CDTIPOOPER_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TipoOper=' + @V_CDTIPOOPER_OLD;
         END;

         IF @V_VR1PERREDBC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' 1PerRecBC=' + CONVERT(VARCHAR,@V_VR1PERREDBC_OLD);
         END;

         IF @V_VR1PERREDBC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' 1PerRecBC=' + CONVERT(VARCHAR,@V_VR1PERREDBC_OLD);
         END;

      END
      ELSE
      IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
         IF (@V_IDENTRSAIDAL_NEW <> @V_IDENTRSAIDAL_OLD) OR
            (@V_CDTIPOOPER_NEW   <> @V_CDTIPOOPER_OLD)   OR
            (@V_CDIMPOSTO_NEW    <> @V_CDIMPOSTO_OLD)    OR
            (@V_CDEMPRESA_NEW    <> @V_CDEMPRESA_OLD)    OR
            (@V_CDINSCESTA_NEW   <> @V_CDINSCESTA_OLD)   OR
            (@V_CDPRODUTO_NEW    <> @V_CDPRODUTO_OLD)    OR
            (@V_CDPAISORIG_NEW   <> @V_CDPAISORIG_OLD)   OR
            (@V_SGESTAORIG_NEW   <> @V_SGESTAORIG_OLD)   OR
            (@V_CDMUNIORIG_NEW   <> @V_CDMUNIORIG_OLD)   OR
            (@V_CDPAISDEST_NEW   <> @V_CDPAISDEST_OLD)   OR
            (@V_SGESTADEST_NEW   <> @V_SGESTADEST_OLD)   OR
            (@V_CDMUNIDEST_NEW   <> @V_CDMUNIDEST_OLD)   OR
            (@V_DTINIVALID_NEW   <> @V_DTINIVALID_OLD)   OR
            (@V_VRINIFAIXA_NEW   <> @V_VRINIFAIXA_OLD)   OR
            (@V_VRFIMFAIXA_NEW   <> @V_VRFIMFAIXA_OLD)   OR
            (@V_VRPARDEDUZ_NEW   <> @V_VRPARDEDUZ_OLD)   OR
            (@V_VRPERREDBC_NEW   <> @V_VRPERREDBC_OLD)   OR
            (@V_VRALIQUOTA_NEW   <> @V_VRALIQUOTA_OLD)   OR
            (@V_CDGRUPOFISC_NEW  <> @V_CDGRUPOFISC_OLD)  OR
            (@V_IDTRATIMPST_NEW  <> @V_IDTRATIMPST_OLD)  OR
            (@V_VRPBCSUBTRIB_NEW <> @V_VRPBCSUBTRIB_OLD) OR
            (@V_IDMUNIORIDES_NEW <> @V_IDMUNIORIDES_OLD) OR
    	      (@V_VR1PERREDBC_NEW  <> @V_VR1PERREDBC_OLD)  BEGIN

            SET @V_TIPO   = '2';
            SET @V_ITPESQ = @V_NRALIQUOTA_OLD;
         END;
      END
      ELSE BEGIN	     
         SET @V_TIPO   = '1';
         SET @V_ITPESQ = @V_NRALIQUOTA_NEW;
      END;
      SELECT @V_CDARVPROD_NEW = CDARVPROD 
      FROM PRODUTO
      WHERE CDPRODUTO = @V_CDPRODUTO_NEW;

      IF @V_CDIMPOSTO_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Impo=' + @V_CDIMPOSTO_NEW;
      END;

      IF @V_CDEMPRESA_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Empr=' + @V_CDEMPRESA_NEW;
      END;

      IF @V_CDINSCESTA_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' InscEsta=' + @V_CDINSCESTA_NEW;
      END;

      IF @V_CDARVPROD_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD_NEW;
      END;

      IF @V_CDPAISORIG_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' PaisOrig=' + @V_CDPAISORIG_NEW;
      END;

      IF @V_SGESTAORIG_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' EstaOrig=' + @V_SGESTAORIG_NEW;
      END;

      IF @V_CDMUNIORIG_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' MunicipOrig=' + @V_CDMUNIORIG_NEW;
      END;

      IF @V_CDPAISDEST_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' PaisDest=' + @V_CDPAISDEST_NEW;
      END;

      IF @V_SGESTADEST_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' EstaDest=' + @V_SGESTADEST_NEW;
      END;

      IF @V_CDMUNIDEST_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' MunicipDest=' + @V_CDMUNIDEST_NEW;
      END;

      IF @V_DTINIVALID_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' DtIniVal=' + CONVERT(VARCHAR,@V_DTINIVALID_NEW);
      END;

      IF @V_VRINIFAIXA_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' IniFaixa=' + CONVERT(VARCHAR,@V_VRINIFAIXA_NEW);
      END;

      IF @V_VRFIMFAIXA_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' FimFaixa=' + CONVERT(VARCHAR,@V_VRFIMFAIXA_NEW);
      END;

      IF @V_VRPARDEDUZ_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' ParcDedu=' + CONVERT(VARCHAR,@V_VRPARDEDUZ_NEW);
      END;

      IF @V_VRPERREDBC_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' PerRecBC' + CONVERT(VARCHAR,@V_VRPERREDBC_NEW);
      END;

      IF @V_VRALIQUOTA_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Aliq=' + CONVERT(VARCHAR,@V_VRALIQUOTA_NEW);
      END;

      IF @V_CDGRUPOFISC_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' GrupFisc=' + @V_CDGRUPOFISC_NEW;
      END;

      IF @V_IDTRATIMPST_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' TratImpST=' + @V_IDTRATIMPST_NEW;
      END;

      IF @V_VRPBCSUBTRIB_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' BCSitTrib=' + CONVERT(VARCHAR,@V_VRPBCSUBTRIB_NEW);
      END;

      IF @V_IDMUNIORIDES_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' MunOrigDest=' + @V_IDMUNIORIDES_NEW;
      END;

      IF @V_IDENTRSAIDAL_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' IdEntrSaid=' + @V_IDENTRSAIDAL_NEW;
      END;

      IF @V_CDTIPOOPER_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' TipoOper=' + @V_CDTIPOOPER_NEW;
      END;

      IF @V_VR1PERREDBC_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' 1PerRecBC=' + CONVERT(VARCHAR,@V_VR1PERREDBC_NEW);
      END;

      IF @V_TIPO <> '0' BEGIN
         IF NOT @V_DESC IS NULL BEGIN
            IF @V_USUARIO IS NOT NULL BEGIN
	          SET  @V_DTOPER = GETDATE();
                  INSERT INTO LOGOPERA
                     (NMTABELA,   DTOPERACAO, NMRESPOPER,
                      IDTIPOOPER, CDPESQITEM, DSOPERACAO)
                  VALUES
                     ('ALIQUOTA', @V_DTOPER, @V_USUARIO,
                      @V_TIPO,    @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSORal INTO @V_ID_COMANDO,
                                    @V_IDENTRSAIDAL_OLD,
                                    @V_CDTIPOOPER_OLD,
                                    @V_CDIMPOSTO_OLD,
                                    @V_CDEMPRESA_OLD,
                                    @V_CDINSCESTA_OLD,
                                    @V_CDPRODUTO_OLD,
                                    @V_CDPAISORIG_OLD,
                                    @V_SGESTAORIG_OLD,
                                    @V_CDMUNIORIG_OLD,
                                    @V_CDPAISDEST_OLD,
                                    @V_SGESTADEST_OLD,
                                    @V_DTINIVALID_OLD,
                                    @V_VRINIFAIXA_OLD,
                                    @V_VRFIMFAIXA_OLD,
                                    @V_VRPARDEDUZ_OLD,
                                    @V_VRPERREDBC_OLD,
                                    @V_VRALIQUOTA_OLD,
                                    @V_CDGRUPOFISC_OLD,
                                    @V_IDTRATIMPST_OLD ,
                                    @V_VRPBCSUBTRIB_OLD,
                                    @V_IDMUNIORIDES_OLD,
                                    @V_NRALIQUOTA_OLD,
                   		            @V_VR1PERREDBC_OLD,
                                    @V_CDMUNIDEST_OLD,

                                    @V_IDENTRSAIDAL_NEW,
                                    @V_CDTIPOOPER_NEW,
                                    @V_CDIMPOSTO_NEW,
                                    @V_CDEMPRESA_NEW,
                                    @V_CDINSCESTA_NEW,
                                    @V_CDPRODUTO_NEW,
                                    @V_CDPAISORIG_NEW,
                                    @V_SGESTAORIG_NEW,
                                    @V_CDMUNIORIG_NEW,
                                    @V_CDPAISDEST_NEW,
                                    @V_SGESTADEST_NEW,
                                    @V_DTINIVALID_NEW,
                                    @V_VRINIFAIXA_NEW,
                                    @V_VRFIMFAIXA_NEW,
                                    @V_VRPARDEDUZ_NEW,
                                    @V_VRPERREDBC_NEW,
                                    @V_VRALIQUOTA_NEW,
                                    @V_CDGRUPOFISC_NEW,
                                    @V_IDTRATIMPST_NEW,
                                    @V_VRPBCSUBTRIB_NEW,
                                    @V_IDMUNIORIDES_NEW,
                                    @V_NRALIQUOTA_NEW,
                		               @V_VR1PERREDBC_NEW,
                                    @V_CDMUNIDEST_NEW;
   END;
   CLOSE      C_CURSORal;
   DEALLOCATE C_CURSORal;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_ALIQUOTA','5.30.000';
GO

